package plugin::similarity::Block;
###############################################################################
# Similarity Search(blog.bulknews.net)Ѥjavascriptߤޤ
# <pre>
# {{similarity permalink,[ץ]}}
# </pre>
# ץn,oe,style,noheader,targetˤλ'key&#61;var'Ǥ
# <pre>
# {{similarity http://example.com/diary/20040101,n&#61;3,noheader&#61;1}}
# </pre>
# oeϥǥեȤeuc-jpǤn100ޤǡ
# <pre>
# {{similarity myself}}
# </pre>
# ǡΥڡΥɥ쥹ưŪꤵޤ
###############################################################################
use strict;

my $UseCache = 1;  # if set false, use javascript.

###############################################################################

sub new {
	return bless {}, shift;
}

sub paragraph {
	my $self = shift;
	my $wiki = shift;
	my ($url,@arg) = @_;
	my %value = map{ split/=/ } @arg if(@arg);

	$value{n}        ||= 10;
	$value{oe}       ||= 'euc-jp';
	$value{style}    ||= 'lite';
	$value{noheader} ||= 0;
	$value{target}   ||= '';

	return Util::paragraph_error("permalinkꤵƤޤ")
	    if(!defined $url);
	return Util::paragraph_error("ͤޤ")
	    if($self->validate(\%value));

	$url = $wiki->get_CGI->self_url if($url eq 'myself');

	if($UseCache){
		return $self->make_paragraph($wiki,$url,\%value);
	}
	else{
		return $self->make_js($url,\%value);
	}
}

sub make_paragraph{
	my $self = shift;
	my $wiki = shift;
	my ($url,$opt) = @_;

	my $config     = Util::load_config_hash($wiki,$wiki->config('config_file'));
	my $cache_ttl  = $config->{similarity_cache_ttl} || 3600 * 8; # (in sec)
	my $cache_dir  = $wiki->config('log_dir') . '/';
	my $cache_file = $cache_dir . Util::url_encode($url) . '.js.cache';
	my $modtime    = (stat($cache_file))[9];

	if( -e $cache_file and (time - $modtime < $cache_ttl) ){
		return $self->get_cache($cache_file);
	}
	else{
		my $content = $self->get_content($url,$opt);
		return (defined $content) ? 
		  $self->store_cache($cache_file,$content) : $wiki->error("Can't Use LWP");
	}
}

sub get_content{
	my $self = shift;
	my $url  = shift;
	my %opt  = %{ (shift) };
	my $lwp  = eval qq| require LWP::Simple | or return undef;

	$url = 'http://bulkfeeds.net/app/similar.js?url=' . Util::url_encode($url)
	       . "&amp;n=$opt{n}&amp;style=$opt{style}&amp;oe=$opt{oe}"
	       . "&amp;target=$opt{target}&amp;noheader=$opt{nohedader}";

	return LWP::Simple::get($url) || '';
}

sub store_cache{
	my $self    = shift;
	my $file    = shift;
	my $content = shift;

	$content =~ s/document\.write\(''\);//mg;
	$content =~ s/^document\.writeln\('//mg;
	$content =~ s/'\);$//mg;

	open(FILE,">$file") or return "Can't write cache file.";
	print FILE $content;
	close(FILE);

	return $content;
}

sub get_cache{
	my $self = shift;
	my $file = shift;
	my $content;

	open(FILE,$file) or return "Can't open cache file.";
	while( my $line = <FILE> ){
		$content .= $line;
	}
	close(FILE);

	return $content;
}


sub make_js{
	my $self  = shift;
	my $url   = shift;
	my %value = %{ (shift) };

	return <<"END";

<div class="similarity">
<script language="JavaScript">
<!--
var url      = '$url';
var n        =  $value{n};
var oe       = '$value{oe}';
var style    = '$value{style}';
var noheader = '$value{noheader}';
var target   = '$value{target}';

document.write(
'<script language="JavaScript" src="http://bulkfeeds.net/app/similar.js?url='
+ escape(url) + '&amp;n=' + n + '&amp;style=' + style + '&amp;oe=' + oe
+ '&amp;target=' + target + '&amp;noheader=' + noheader
+ '"></script>');
//-->
</script>
</div>

END
}

# if any invalid value, return true. otherwise false.
#  IN : hash ref to optional parameters
#  OUT: true or false
sub validate{
	my $self      = shift;
	my ($ref) = @_;

	return 1 if( !Util::check_numeric($ref->{n}) );
	return 1 if( !Util::check_numeric($ref->{noheader}) );
	return 1 if( $ref->{oe}     =~ /[^-\w]/ or length $ref->{oe}     > 50);
	return 1 if( $ref->{style}  =~ /[^-\w]/ or length $ref->{style}  > 50);
	return 1 if( $ref->{target} =~ /[^-\w]/ or length $ref->{target} > 50);
	return 1 if( $ref->{n} > 100 );
}

1;
